#include "houses/elements.inc"

#declare TestTxt = 0;

#declare FacadeTxt = 
texture {pigment {color rgb 1} finish {diffuse 0 ambient 1}}

#declare WindowFrameTxt = 
texture {pigment {color rgb 1} finish {diffuse 0 ambient 1}}

#declare Glass = object{
	E1
texture {pigment {color rgb 1} finish {diffuse 0 ambient 1}}
}

#declare WindowFrame1 = union {
	object{E5 scale<0.004, 0.05, 0.03> translate<0.01, 0.01, 0>}
	object{E5 scale<0.004, 0.05, 0.03> translate<0.025 - 0.002, 0.01, 0>}
	object{E5 scale<0.004, 0.05, 0.03> translate<0.04 - 0.004, 0.01, 0>}
	  
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.01, 0.00001>}
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.025 - 0.002, 0.00001>}
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.045 - 0.002, 0.00001>} 
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.06 - 0.004, 0.00001>}

	object{Glass scale<0.04, 0.06, 1> translate<0.005, 0.005, 0.0005>}
	texture{WindowFrameTxt}
}

#declare Window1 = union {
	object{E5 scale<0.05, 0.01, 0.03>}
	object{E5 scale<0.05, 0.01, 0.03> translate <0, 0.06, 0>}
	object{E5 scale<0.01, 0.05, 0.03> translate<0, 0.01, 0>}
	object{E5 scale<0.01, 0.05, 0.03> translate<0.04, 0.01, 0>}
  
	object{WindowFrame1 translate z*0.002}
	
	translate -z*0.0026
}

#declare WindowFrame2 = union {                 
	object{E5 scale<0.004, 0.08, 0.03> translate<0.01, 0.01, 0>}
	object{E5 scale<0.004, 0.08, 0.03> translate<0.025 - 0.002, 0.01, 0>}
	object{E5 scale<0.004, 0.08, 0.03> translate<0.04 - 0.004, 0.01, 0>}
	  
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.01, 0.00001>}
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.03 - 0.002, 0.00001>}
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.05 - 0.002, 0.00001>} 
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.07 - 0.002, 0.00001>}
	object{E5 scale<0.022, 0.004, 0.03> translate<0.014, 0.09 - 0.004, 0.00001>}

	object{Glass scale<0.04, 0.09, 1> translate<0.005, 0.005, 0.0005>}
	texture{WindowFrameTxt}
}

#declare Window2 = union {
	object{E5 scale<0.06, 0.11, 0.03> translate<-0.005, -0.005, 0.0027>}
	
	object{E5 scale<0.05, 0.01, 0.03>}
	object{E5 scale<0.05, 0.01, 0.03> translate <0, 0.09, 0>}
	object{E5 scale<0.01, 0.08, 0.03> translate<0, 0.01, 0>}
	object{E5 scale<0.01, 0.08, 0.03> translate<0.04, 0.01, 0>}
  
	object{WindowFrame2 translate z*0.002}
	
	translate -z*0.003
}

#declare House16 = union {
	// facade
	object{E1 scale<0.4, 0.54, 1> translate -y*0.1}
	
	// top
	object{E6 scale<0.4, 0.01, 0.4> translate<0, 0.44, -0.005>}
	object{E6 scale<0.4, 0.01, 0.4> translate<0, 0.45, -0.01>}
	
	// bars
  	object{E5 scale<0.4, 0.03, 0.003> translate<0, 0.23, -0.003>}
  	object{E5 scale<0.4, 0.02, 0.002> translate<0, 0.235, -0.005>}
 
	// 1st floor
	object{Window1 translate<0.05, 0.1, 0>}
	object{Window1 translate<0.175, 0.1, 0>}
	object{Window1 translate<0.3, 0.1, 0>}
    
    // 3rd floor
    object{Window2 translate<0.03, 0.3, 0>}
    object{Window2 translate<0.1, 0.3, 0>}
    object{Window2 translate<0.175, 0.3, 0>}
    object{Window2 translate<0.25, 0.3, 0>}
    object{Window2 translate<0.32, 0.3, 0>}
    
	texture{FacadeTxt scale<0.4, 0.56, 1> translate<0, -0.1, 0>}
	texture {pigment {color rgb 1} finish {diffuse 0 ambient 1}}
}